Name: kgames
Version: 1.0
Release: 2
Copyright: MIT
Group: X11/Games/Strategy
BuildRoot: /var/tmp/kgames-root
Source: ftp://ftp.x.org/contrib/games/kgames-1.0.tar.gz
Patch: kgames-1.0.patch
Summary:  a collection of X11 solitaire games plus dominos, reversi and xmille.
Packager: John Salmon <johns@cacr.caltech.edu>
Vendor: Keith Packard <keithp@ncd.com>

%description
A collection of X11 games including dominos, canfield, cribbage, klondike,
montana, spider, thieves, towers, mcarlo, reversi, slyfox and xmille.  They
use an early(?) version of the Layout widget in the Xaw3d package.

%prep
%setup
%patch -p1

%build
xmkmf
make Makefiles
make
# copy xmille/README so we can use it in %doc without conflict
cp xmille/README xmille.README

%install
make DESTDIR=$RPM_BUILD_ROOT install install.man

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README README.HPPD HPUX.Install xmille.README
# Actually, this is everything under the $RPM_BUILD_ROOT
# but it shouldn't hurt to be a little more specific.
/usr/X11R6/bin/kspider
/usr/X11R6/bin/kcanfield
/usr/X11R6/bin/kklondike
/usr/X11R6/bin/kmontana
/usr/X11R6/bin/xmille
/usr/X11R6/bin/ktowers
/usr/X11R6/bin/kthieves
/usr/X11R6/bin/kcribbage
/usr/X11R6/bin/dominos
/usr/X11R6/bin/slyfox
/usr/X11R6/bin/mcarlo
/usr/X11R6/bin/xreversi
/usr/X11R6/include/X11/bitmaps/bob
/usr/X11R6/include/X11/bitmaps/playing_card
/usr/X11R6/include/X11/bitmaps/spade_lg
/usr/X11R6/lib/X11/app-defaults/KSpider
/usr/X11R6/lib/X11/app-defaults/KSpider-color
/usr/X11R6/lib/X11/app-defaults/KCanfield
/usr/X11R6/lib/X11/app-defaults/KCanfield-color
/usr/X11R6/lib/X11/app-defaults/KKlondike
/usr/X11R6/lib/X11/app-defaults/KMontana
/usr/X11R6/lib/X11/app-defaults/Mille
/usr/X11R6/lib/X11/app-defaults/KTowers
/usr/X11R6/lib/X11/app-defaults/KThieves
/usr/X11R6/lib/X11/app-defaults/KThieves-color
/usr/X11R6/lib/X11/app-defaults/Cribbage
/usr/X11R6/lib/X11/app-defaults/Dominos
/usr/X11R6/lib/X11/app-defaults/Dominos-color
/usr/X11R6/lib/X11/app-defaults/SlyFox
/usr/X11R6/lib/X11/app-defaults/SlyFox-hard
/usr/X11R6/lib/X11/app-defaults/MonteCarlo
/usr/X11R6/lib/X11/app-defaults/Xreversi
/usr/X11R6/man/man6/kspider.6
/usr/X11R6/man/man6/kcanfield.6
/usr/X11R6/man/man6/kklondike.6
/usr/X11R6/man/man6/kmontana.6
/usr/X11R6/man/man6/xmille.6
/usr/X11R6/man/man6/ktowers.6
/usr/X11R6/man/man6/kthieves.6
/usr/X11R6/man/man6/kcribbage.6
/usr/X11R6/man/man6/dominos.6
/usr/X11R6/man/man6/slyfox.6
/usr/X11R6/man/man6/mcarlo.6
/usr/X11R6/man/man6/xreversi.6

%changelog
* Tue Dec 29 1998 John Salmon <johns@fishnet.caltech.edu>

Deleted an errant Summary: line in the spec file that.  Release version 2.

* Fri Dec 25 1998 John Salmon <johns@fishnet.caltech.edu>

kgames finally works under linux.  There were several problems:

1) POSIX lexical analyzers like flex don't allow you to redefine
input() and unput(c).  Instead, you're supposed to #define YY_INPUT.
Changed Xkw/laylex.l to conform to this requirement, with inspiration from
laylex.l in the Xaw3d distribution.

2) kcribbage/*.c use a function called 'remove()'.  This conflicts
with a function in stdio that does something completely different.  I
changed the name to 'remove_card()'.

3) reversi's Imakefile forgot to build edges.out.

4) xmille/varpush.c used gets, which generates a dire warning from ld.
Changed to fgets.

5) xmille/save.c: use #include <errno.h> instead of an explicit
reference to errno and sys_errlist.

6) the Imakefiles in the subdirectories all contain a preamble that
specifies system-specific locations.  This kind of thing is correctly
handled by xmkmf or (at worst) command-line args to make.  Hard-coded
definitions of PROJECTROOT, BINDIR, LIBDIR, MANPATH, INSTALL and
MKDIRHIER were deleted from all Imakefiles.

7) These are games, so man pages should go in man6.  There's probably a
cleaner way to accomplish this, but I did it by adding:
MANSUFFIX=6
MANDIR=$(MANSOURCEPATH)$(MANSUFFIX)
to the top of each Imakefile

8) tell Xkw/Imakefile to install the bitmaps for spade_lg, playing_card
and bob.  The target directory is INCDIR/X11/bitmaps, not INCDIR/bitmaps.

9) The app-defaults/*-color.ad contained, e.g., #include
"KCanfield.ad".  But the file is actually installed as "KCanfield",
without the .ad suffix.  Changing the -color.ad files fixes the 'Shell
widget ??? has zero width and/or height' problems.

KNOWN BUGS:  
- lots of compiler warnings about questionable assignments, mismatched 
parameters, etc. during build.
- dominos and kcanfield dump core with a floating-point exception on alpha
systems.  This is probably related to the warnings during the build.

